structure Aux =
struct

(*List functions*)
fun replace(_,_,[]) = NONE
  | replace(x1,x2,x'::xs) = if x1 = x' 
                              then SOME(x2::xs) 
                              else let val res = replace(x1,x2,xs)
                                   in case res of
                                      NONE => NONE
                                     |SOME(xs') => SOME(x'::xs')
                                   end

fun member(x,xs) = List.exists (fn x' => x' = x) xs


fun remove(x,xs) = List.filter (fn x' => x <> x') xs

fun removeDoubles(x::xs) = if member(x,xs) then removeDoubles(xs) else x::removeDoubles(xs)
  | removeDoubles [] = []

fun union(xs,ys) = removeDoubles(xs@ys)

fun meltList(x::xs) = x @ (meltList xs)
  | meltList [] = []
  
fun count(x,xs) = length(List.filter (fn x' => x = x') xs)

fun getLastElement([x]) = x
  | getLastElement(x::xs) = getLastElement(xs)
  | getLastElement([]) = raise List.Empty

end