structure MC = 
struct

open Types
open BreachStates
open EvalConstraints

(*
fun findSecrecyBreach(paths,breach,leaks) = 
  let val _ = print ("searching "^Int.toString(List.length(paths))^" paths of length "^Int.toString(length(hd(paths))-1)^"\n")
      val paths' = List.filter (fn nodeRef::path => BreachStates.isPotentialSecrecyBreachState(nodeRef,breach)) paths
  in 
    case EvalConstraints.hasSecrecyBreachLS(paths',[],breach,leaks) of
      (NONE,paths'') => findSecrecyBreach(Graph.extendPaths(paths''),breach,leaks) (* if we never find the breach we loop here *)
     |(SOME(sub,psi,p,cs),_) => (sub,psi,p,cs) (*when we find a breach the corresponding substitution and path is returned*)
  end

fun findAuthenticationBreach(paths,(orig,dest),leaks) = 
  let val _ = print ("searching "^Int.toString(List.length(paths))^" paths of length "^Int.toString(length(hd(paths))-1)^"\n")
      val paths' = List.filter (fn nodeRef::path => BreachStates.isPotentialAuthenticationBreachState(nodeRef,(orig,dest))) paths
  in 
    case EvalConstraints.hasAuthenticationBreachLS(paths',[],(orig,dest),leaks) of
      (NONE,paths'') => findAuthenticationBreach(Graph.extendPaths(paths''),(orig,dest),leaks) (* if we never find the breach we loop here *)
     |(SOME(sub,psi,path,cs),_) => (sub,psi,path,cs) (*when we find a breach the corresponding substitution and path is returned*)
  end

*)


fun searchForBreach(breach,protocol) = 
  let val (init,_,leakterms) = Flow.createGraph(Flow.addLabelS(protocol))
      val pathCs = mkPathCs(init,leakterms)
  in 
    case EvalConstraints.search([pathCs],[],breach) of
      SOME(path,sub,psi,state) =>  (path,sub,psi,state) 
  end

end                                 