structure Prot = 
struct

open Types
open LysaN

val A = NAME("A")
val B = NAME("B")
val S = NAME("S")
val I = NAME("I")
val Z = NAME("Z")

val K = NAME("K")
val Msg = NAME("Msg")

val A1 = NAME("A1")
val A2 = NAME("A2")
val A3 = NAME("A3")
val A4 = NAME("A4")

val B1 = NAME("B1")
val B2 = NAME("B2")
val B3 = NAME("B3")
val B4 = NAME("B4")

val u1 = NAME("u1")
val u2 = NAME("u2")
val u3 = NAME("u3")
val u4 = NAME("u4")

val xA = VAR("xA")
val xA' = DEFVARP("xA")
val xB = VAR("xB")
val xB' = DEFVARP("xB")
val yA = VAR("yA")
val yA' = DEFVARP("yA")
val yB = VAR("yB")
val yB' = DEFVARP("yB")
val zA = VAR("zA")
val zA' = DEFVARP("zA")
val zB = VAR("zB")
val zB' = DEFVARP("zB")
val xK = VAR("xK")
val xK' = DEFVAR("xK")
val yK = VAR("yK")
val yK' = DEFVAR("yK")
val zK = VAR("zK")
val zK' = DEFVAR("zK")
val yMsg = VAR("yMsg")
val yMsg' = DEFVAR("yMsg")

val xNb' = DEFVAR("xNb")
val xNb = VAR("xNb")
val yNa = VAR("yNa")
val yNa' = DEFVAR("yNa")
val zNb' = DEFVAR("zNb")
val zNb = VAR("zNb")
val zNa = VAR("zNa")
val zNa' = DEFVAR("zNa")

val xKNEW' = DEFVAR("xKNEW")
val xNbNEW' = DEFVAR("xNbNEW")
val xKNEW = VAR("xKNEW")
val xNbNEW = VAR("xNbNEW")

val succ = NAME("succ")
val oK = NAME("oK")
val oNb = NAME("oNb")
val oNa = NAME("oNa")
val oMsg = NAME("oMsg")
val Q = NAME("Q")

val KNEW = NAME("KNEW")
val NbNEW = NAME("NbNEW")

val Na = NAME("Na")
val Nb = NAME("Nb")

val xEnc = VAR("xEnc")
val xEnc' = DEFVAR("xEnc")

val y = VAR("y")
val y' = DEFVAR("y")
val MS = NAME "MS"
val MP = NAME "MP"
val xS = VAR "xS"
val xS' = DEFVAR "xS"
val xP = VAR "xP"
val xP' = DEFVAR "xP"
val Kab = NAME "Kab"

(*------------------------*)


(*origdest*)

(*
val S = NAME("S")
val P = NAME("P")
val K = NAME("K")

val xS = VAR("xS")
val xS' = DEFVAR("xS")
val xP = VAR("xP")
val xP' = DEFVAR("xP")

val a1 = NAME("a1")
val a2 = NAME("a2")
val b1 = NAME("b1")
val b2 = NAME("b2")

val Pa = NEW(S,
         OUT([ENC([S],K,(a1,DEST b1))],
         NEW(P,
         OUT([ENC([P],K,(a2,DEST b2))],
         NIL))))

val Pb = INP([ENC([xS'],K,(b1,ORIG a1))],
         INP([ENC([xP'],K,(b2,ORIG a2))],
         OUT([xP],
         NIL)))

val origdest = NEWS(K,PAR([LOOP("A",Pa),LOOP("B",Pb)]))
*)
(*------------------------*)


(*WMF variant 1. Running example protocol*)

val Pa = NEW(K,
         OUT([A,B,ENC([K],KEY(A),(A,DEST S))],
         NEW(Msg,
         OUT([ENC([Msg],K,(A,DEST B))],
         NIL))))

val Pb = INP([yA',ENC([yK'],KEY(B),(B,ORIG S))],
         INP([ENC([yMsg'],yK,(B,ORIG yA))],
         NIL))

val Ps = INP([zA',zB',ENC([zK'],KEY(zA),(S,ORIG zA))],
         OUT([zA,ENC([zK],KEY(zB),(S,DEST zB))],
         NIL))

val wmfv1 = NEWS(KEY(A),NEWS(KEY(B),PAR([LOOP("A",Pa),LOOP("B",Pb),LOOP("S",Ps)])))

(* WMF variant 2. Principal names encrypted *)


val Pa = (*INP([xA',xB'],*)
         NEW(K,
         OUT([A,ENC([B,K],KEY(A),(A,DEST S))],
         NEW(Msg,
         OUT([ENC([Msg],K,(A,DEST B))],
         NIL))))

val Pb = (*INP([yA',yB'],*)
         INP([ENC([yA',yK'],KEY(B),(B,ORIG S))],
         INP([ENC([yMsg'],yK,(B,ORIG yA))],
         NIL))

val Ps = INP([zA',ENC([zB',zK'],KEY(zA),(S,ORIG zA))],
         OUT([ENC([zA,zK],KEY(zB),(S,DEST zB))],
         NIL))

val leak = OUT([
oK,
ENC([B,oK],KEY(A),(Z,DEST Z)),
ENC([A,oK],KEY(B),(Z,DEST Z)),
ENC([oMsg],oK,(Z,DEST Z))
],NIL)

val wmfv2 = NEWS(KEY(A),NEWS(KEY(B),PAR([LOOP("A",Pa),LOOP("B",Pb),LOOP("S",Ps)])))
val wmfv2Leak = NEWS(KEY(A),NEWS(KEY(B),PAR([LOOP("A",Pa),LOOP("B",Pb),LOOP("S",Ps),LOOP("leak",leak)])))


(*----  needham schroeder ------*)

val Pleak = NEW(oK,NEW(oNa,NEW(oNb,NEW(oMsg,NEW(succ,
OUT([oK,oNa,oNb,succ,
ENC([A,oK],KEY(B),(Z,DEST Z)),
ENC([B,oNa,oK,ENC([A,oK],KEY(B),(Z,DEST Z))],KEY(A),(Z,DEST Z)),
ENC([Q,oMsg],oK,(Z,DEST Z)),
ENC([oNb],oK,(Z,DEST Z)),
ENC([ENC([oNb],succ,(Z,DEST Z))],oK,(Z,DEST Z))],
NIL))))))

val Pa = NEW(Na,NEW(Msg,
         OUT([A,B,Na],
         INP([ENC([B,Na,xK',xEnc'],KEY(A),(A1,ORIG S))],
         OUT([xEnc],
         INP([ENC([xNb'],xK,(A2,ORIG B2))],
         OUT([ENC([ENC([xNb],succ,(Z,DEST Z))],xK,(A3,DEST B3))],
         OUT([ENC([Q,Msg],xK,(A4,DEST B4))],
         NIL))))))))
         
val Pb = NEW(Nb,
         INP([ENC([A,yK'],KEY(B),(B1,ORIG S))],
         OUT([ENC([Nb],yK,(B2,DEST A2))],
         INP([ENC([ENC([Nb],succ,(Z,ORIG Z))],yK,(B3,ORIG A3))],
         INP([ENC([Q,yMsg'],yK,(B4,ORIG A4))],
         NIL)))))

val Ps = NEW(K,
         INP([A,B,zNa'],
         OUT([ENC([B,zNa,K,ENC([A,K],KEY(B),(S,DEST B1))],KEY(A),(S,DEST A1))],
         NIL)))
         
val nsLeak = NEWS(KEY(A),NEWS(KEY(B),PAR([LOOP("leak",Pleak),LOOP("A",Pa),LOOP("B",Pb),LOOP("S",Ps)])))


(*------andrew secure RPC--------*)

val Pa = NEW(Na,
         OUT([A,ENC([u1,Na],K,(A1,DEST B1))],
           INP([ENC([u2,ENC([Na],succ,(Z,ORIG Z)),xNb'],K,(A2,ORIG B2))],
           OUT([ENC([u3,ENC([xNb],succ,(Z,DEST Z))],K,(A3,DEST B3))],
           INP([ENC([u4,xKNEW',xNbNEW'],K,(A4,ORIG B4))],
           NEW(Msg,
           OUT([ENC([Msg],xKNEW,(A, DEST B))],
           NIL)))))))

val Pb = INP([A,ENC([u1,yNa'],K,(B1,ORIG A1))],
           NEW(Nb,
           OUT([ENC([u2,ENC([yNa],succ,(Z, DEST Z)),Nb],K,(B2,DEST A2))],
           INP([ENC([u3,ENC([Nb],succ,(Z,ORIG Z))],K,(B3,ORIG A3))],
           NEW(KNEW,NEW(NbNEW,
           OUT([ENC([u4,KNEW,NbNEW],K,(B4,DEST A4))],
           INP([ENC([yMsg'],KNEW,(B, ORIG A))],
           NIL))))))))

val leak = OUT([oK,ENC([u4,oK,oNb],K,(Z,DEST Z))],NIL)

val andrew = NEWS(K,PAR([LOOP("A",Pa),LOOP("B",Pb)]))
val andrewLeak = NEWS(K,PAR([LOOP("A",Pa),LOOP("B",Pb),LOOP("leak",leak)]))

(*------ Yahalom -----------------*)

val Pa  = NEW(Na,
          OUT([A,Na],
          INP([ENC([B,Na,xK',xNb'],KEY(A),(A,ORIG S)),xEnc'],
          OUT([xEnc,ENC([xNb],xK,(A,DEST B))],
          NEW(Msg,
          OUT([ENC([Msg],xK,(A,DEST B))],
          NIL))))))
           
val Pb  = INP([yA',yNa'],
          NEW(Nb,
          OUT([B,ENC([yA,yNa,Nb],KEY(B),(B, DEST S))],
          INP([ENC([yA,yK'],KEY(B),(B,ORIG S)),ENC([Nb],yK,(B,ORIG yA))],
          INP([ENC([yMsg'],yK,(B,ORIG yA))],
          NIL)))))

val Ps  = INP([zB',ENC([zA',zNa',zNb'],KEY(zB),(S, ORIG zB))],
          NEW(K,
          OUT([ENC([zB,zNa,K,zNb],KEY(zA),(S,DEST zA)),ENC([zA,K],KEY(zB),(S,DEST zB))],
          NIL)))

val leak = OUT([
oK,oNa,oNb,
ENC([oNb],oK,(Z,DEST Z)),
ENC([oMsg],oK,(Z,DEST Z)),
ENC([A,oNa,oNb],KEY(B),(Z, DEST Z)),
ENC([B,oNa,oK,oNb],KEY(A),(Z,DEST Z)),
ENC([A,oK],KEY(B),(Z,DEST Z))
],NIL)

val yahalom = NEWS(KEY(A),NEWS(KEY(B),PAR([LOOP("A",Pa),LOOP("B",Pb),LOOP("S",Ps),LOOP("leak",leak)])))
           

(*-------index test--------*)

val Pa = INP([ENC([y'],KEY(A),(A1,ORIG Z))],
         OUT([ENC([y],KEY(A),(A2,DEST Q))],
         NIL))

val leak = OUT([ENC([B],KEY(A),(Z,DEST Z))],NIL)

val indextest = NEWS(KEY(A),PAR([LOOP("A",Pa),LOOP("leak",leak)]))

(*-------unification test--------*)

val Pa = OUT([ENC([ENC([A],succ,(Z,DEST Z))],KEY(A),(A1,DEST Q))],
         INP([ENC([y'],KEY(A),(A2,ORIG Z))],
         NIL))

    
val unificationtest = NEWS(KEY(A),PAR([LOOP("A",Pa)]))

(* ------test cases ------------*)

(*annotation 1*)
val P = INP([xK'],
        NEW(Msg,
        OUT([ENC([Msg],xK,(A,DEST B))],
        NIL)))
val SAnnot1 = LOOP("P",P)

(*annotation 2*)
val P = NEW(K,
        OUT([K],
        INP([ENC([yMsg'],K,(B,ORIG A))],
        NIL)))

val SAnnot2 = LOOP("P",P)

(*annotation 3*)

val Pa = NEW(MS,NEW(MP,
         OUT([ENC([MS],Kab,(A1,DEST B1))],
         OUT([ENC([MP],Kab,(A2,DEST B2))],
         NIL))))

val Pb = INP([ENC([xS'],Kab,(B1,ORIG A1))],
         INP([ENC([xP'],Kab,(B2,ORIG A2))],
         OUT([xP],
         NIL)))
         
val SAnnot3 = NEWS(Kab,PAR([LOOP("A",Pa),LOOP("B",Pb)]))

(*complex key*)
val P = INP([xA'],NEW(Msg,OUT([ENC([Msg],KEY(xA),(S,DEST A))],NIL)))

val SComplexKey = LOOP("S",P)

(*Intruder key and crypto-point*)
val P = NEW(Msg,OUT([ENC([Msg],KEY(I),(S,DEST I))],NIL))
val SIKey = LOOP("S",P)


(*------------------------------------------------------------------*)
val protocolList = [
("Test case Annot 1",SAnnot1),
("Test case Annot 2",SAnnot2),
("Test case Annot 3",SAnnot3),
("Test case Complex key",SComplexKey),
("Test case Intruder key and crypto-point",SIKey),
("WMF, variant 1, (Running example protocol",wmfv1),
("WMF, variant 2, principal names encrypted",wmfv2),
("WMF, variant 2, principal names encrypted, leak",wmfv2Leak),
("needham schroeder with leak",nsLeak),
("andrew secure RPC ",andrew),
("andrew secure RPC with leak",andrewLeak),
("yahalom",yahalom)
]

end