structure DY2 = 
struct

open LysaN
open Aux
open ToString


fun union(s::set1,set2) = if member(s,set2) then union(set1,set2) else union(set1,s::set2)
  | union([],set2) = set2

fun subset(x::xs,xs') = member(x,xs') andalso subset(xs,xs')
  | subset([],xs) = true

fun add(x,xs) = if member(x,xs) then xs else x::xs

fun split(ENC(encTs,key,cpform)::ts) = let val (encs',ts') = split(ts)
                        in (ENC(encTs,key,cpform)::encs',ts') end
  | split(t::ts) = let val (encs',ts') = split(ts)
                        in (encs',t::ts') end
  | split [] = ([],[])

fun decomposeEncryption(ENC(ts,key,_),ts') = if member(key,ts') then ts else []



fun decomposeDyKn'(enc::encs,ts) = let val (encs',ts') = decomposeDyKn'(encs,ts)
                                      val (newEnc,newTs) = split(decomposeEncryption(enc,ts'))
                                  in (union(newEnc,(add(enc,encs'))),union(newTs,ts')) end
  | decomposeDyKn'([],ts) = ([],ts)

fun decomposeDyKn(encs,ts) = let val (encs',ts') = decomposeDyKn'(encs,ts)
                                 in case (encs=encs' andalso ts=ts') of
                                    false => decomposeDyKn(encs',ts')
                                   |true  => (encs,ts)
                                 end

end